@import 'colors';

$fa-font-path: "../node_modules/font-awesome/fonts";
$font-size: 14px;
$row-height: $font-size + 4px;
$prompt-padding: 5px;
$default-shadow: 0 2px 8px 1px rgba(0, 0, 0, 0.3);

@import '../node_modules/font-awesome/scss/font-awesome';
@import '../node_modules/octicons/octicons/sprockets-octicons';

// Fix the issue when icons aren't displayed.
// https://github.com/black-screen/black-screen/issues/95
.fa {
  transform: translate(0, 0);
}

@font-face {
  font-family: 'octicons';
  src: url("../node_modules/octicons/octicons/octicons.eot?#iefix") format("embedded-opentype"),
  url("../node_modules/octicons/octicons/octicons.woff") format("woff"),
  url("../node_modules/octicons/octicons/octicons.ttf") format("truetype"),
  url("../node_modules/octicons/octicons/octicons.svg#octicons") format("svg");
  font-weight: normal;
  font-style: normal;
}

a {
  color: map-get($colors, 'blue');
}

@each $color, $value in $colors {
  [data-color='#{$color}'] {
    color: $value;
  }

  [data-background-color='#{$color}'] {
    background-color: $value;
  }
}

[data-cursor='true'] {
  background-color: map-get($colors, 'white');
  color: map-get($colors, 'black');
}

[data-weight='bold'] {
  font-weight: bold;
}

[data-underline='true'] {
  text-decoration: underline;
}

@mixin info-panel {
  padding: 8px 0 6px 0.6em;
  min-height: 2em;
  line-height: 1.3;
  background-color: $panel-color;
}

* {
  box-sizing: border-box;
}

::selection {
  background: map-get($colors, 'selection-color');
}

html {
  -webkit-backface-visibility: hidden;
}

body, pre {
  background-color: $background-color;
  color: map-get($colors, 'white');
  font-family: 'Hack', 'Meslo LG S for Powerline', 'Menlo', monospace !important;
  font-size: $font-size;
  margin: 0;
}

.jobs {
  margin-bottom: 40px;
}

.prompt-wrapper {
  position: relative;
  padding-top: $prompt-padding;
  background-color: map-get($colors, 'bright-black');

  $decoration-width: 30px;
  $height: 17px;
  $arrow-z-index: 2;
  $progress-bar-stripes-size: 30px;

  @keyframes progress-bar-stripes {
    from {
      background-position: 0 0;
    }
    to {
      background-position: $progress-bar-stripes-size 0;
    }
  }

  &.fixedsticky-on {
    width: 100%;
    box-shadow: $default-shadow;
  }

  .prompt-decoration {
    display: inline-block;
    height: 17px;
  }

  .arrow {
    position: relative;
    width: $decoration-width;
    height: $height;
    margin: 0 auto;
    overflow: hidden;
    z-index: $arrow-z-index;

    &:after {
      content: '';
      position: absolute;
      width: 200%;
      height: 200%;
      top: -11px;
      right: -8px;
      background-color: lighten(map-get($colors, 'bright-black'), 10% );
      transform-origin: 54% 0;
      transform: rotate(45deg);
      z-index: $arrow-z-index - 1;

      background-size: 0; // Is used to animate the in-progress arrow.
    }
  }

  &.failure {
    .arrow:after {
      background-color: map-get($colors, 'red');
    }
  }
  .prompt-info {
    position: absolute;
    left: 6px;
    top: 6px;
    z-index: 2;
  }

  &.interrupted {
    .arrow:after {
      background-color: map-get($colors, 'red');
    }

    .prompt-info {
      @extend .fa;
      @extend .fa-close;
      color: map-get($colors, 'black');
    }
  }

  &.in-progress {
    .arrow:after {
      transition: background 0.1s step-end 0.3s;
      animation: progress-bar-stripes 0.5s linear infinite;
      background-image: linear-gradient(45deg, map-get($colors, 'bright-black') 25%, transparent 25%, transparent 50%, map-get($colors, 'bright-black') 50%, map-get($colors, 'bright-black') 75%, transparent 75%, transparent);
      background-size: $progress-bar-stripes-size $progress-bar-stripes-size;
    }
  }

  .prompt {
    position: absolute;
    left: $decoration-width - 10px;
    right: 0;
    padding: 0 20px;
    height: $height;
    color: map-get($colors, 'white');
    background-color: map-get($colors, 'bright-black');
    font-size: $font-size;

    @mixin common {
      display: inline-block;
      white-space: pre-wrap;
      -webkit-appearance: none;
      border: none;
      outline: none;
    }

    @include common;

    &:focus {
      @include common;
    }
  }

  .actions {
    float: right;
    margin-right: 15px;

    @mixin action {
      text-align: center;
      width: $font-size;
      display: inline-block;
      margin: 0 3px;
    }

    .scroll-to-top {
      @include action;
      color: map-get($colors, 'white');
    }

    .decoration-toggle {
      @include action;
      color: map-get($colors, 'green');

      &.disabled {
        color: map-get($colors, 'white');
      }
    }
  }
}

.job {
  .output.alternate {
    zoom: 0.1;
  }
  &.in-progress {
    .output.alternate {
      position: fixed;
      zoom: 1;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      z-index: 4;

      margin: 0;
      padding: 5px 0 0 0;
    }
  }
}

.output {
  $output-margin: 10px;
  margin: $output-margin 0;

  .output-cut {
    $height: $font-size * 2.6;
    @mixin jagged-border($darken-percent) {
      background: -webkit-linear-gradient(darken($panel-color, $darken-percent) 0%, transparent 0%),
                  -webkit-linear-gradient(135deg, $background-color 33.33%, transparent 33.33%) 0 0,
                  $background-color -webkit-linear-gradient(45deg, $background-color 33.33%,
                  darken($panel-color, $darken-percent) 33.33%) 0 0;
      background-repeat: repeat-x;
      background-size: 0 100%, 15px 50px, 15px 50px;
    }

    &:before {
      margin-right: 10px;
    }
    @extend .octicon;
    @extend .octicon-unfold;

    position: relative;
    top: -10px;
    width: 100%;
    height: $height;
    text-align: center;
    padding-top: ($height - $font-size) / 3;
    color: lighten($background-color, 30%);

    @include jagged-border(0%);

    &:hover {
      @include jagged-border(2%);
      color: lighten($background-color, 35%);
      cursor: pointer;
    }
  }
  // To display even empty rows. The height might need tweaking.
  // TODO: Remove if we always have a fixed buffer width.
  .row {
    margin: 0 $output-margin;
    min-height: $row-height;
  }
}

#black-screen {
  margin-bottom: 24px;
}

#sizes-calculation {
  position: absolute;
  visibility: hidden;
  height: $row-height;
  width: auto;
  white-space: nowrap;
}

.application {
  display: flex;

  flex-wrap: nowrap;
  flex-direction: column;

  position: absolute;
  width: 100%;
  top: 0;
  bottom: 2em;
}

.terminal {
  height: 100%;
  width: 100%;
  flex: 1;
  overflow-x: scroll;

  &.inactive {
    opacity: 0.4;
    border: 1px solid map-get($colors, 'white');

    & .jobs {
      pointer-events: none;
    }
  }
}

.status-line {
  position: fixed;
  bottom: 0;
  width: 100%;
  z-index: 3;

  @include info-panel;

  .current-directory {
    display: inline-block;

    &:before {
      @extend .octicon;
      @extend .octicon-file-directory;
      margin-right: 5px;
    }
  }

  .vcs-data {
    display: inline-block;
    float: right;
    margin-right: 10px;

    .status {
      display: inline-block;

      &:before {
        @extend .octicon;
        @extend .octicon-git-branch;
        margin-right: 5px;
      }

      &.dirty {
        color: map-get($colors, 'blue');
      }
    }
  }
}

pre {
  white-space: pre-wrap;
}

.autocomplete {
  position: absolute;
  min-width: 250px;

  box-shadow: $default-shadow;
  background-color: map-get($colors, 'black');

  ul {
    max-height: 300px;

    overflow: auto;

    padding: 0;
    margin: 0;

    li {
      list-style-type: none;
      padding: 2px;

      .value {
        padding-right: 30px;
      }

      .synopsis {
        float: right;
        opacity: 0.5;
        font-size: 0.8em;
        margin-top: 0.65em;
        margin-right: 5px;
      }

      .score {
        color: map-get($colors, 'red');
        float: right;
        font-size: 0.8em;
        margin: 0.3em 3px 0 8px;

        border-radius: 45%;

        width: 40px;
        height: 20px;
        padding: 3px;

        border: 1px solid;
        text-align: center;
      }

      .icon:before {
        display: inline-block;
        content: ' ';

        width: 2em;
        height: 2em;
        line-height: 2em;


        vertical-align: middle;
        text-align: center;
        font-style: normal;

        opacity: .5;
        margin-right: 10px;

        background-color: rgba(0, 0, 0, 0.15);
      }

      &.alias .icon {
        @extend .fa;
        @extend .fa-at;
        color: map-get($colors, 'yellow');
      }

      &.file .icon {
        @extend .fa;
        @extend .fa-file;
      }

      &.executable .icon {
        @extend .fa;
        @extend .fa-asterisk;
        color: map-get($colors, 'green');
      }

      &.history .icon {
        @extend .fa;
        @extend .fa-history;
        color: map-get($colors, 'blue');
      }

      &.history-expansion .icon {
        @extend .fa;
        @extend .fa-exclamation;
        color: map-get($colors, 'blue');
      }

      &.command .icon {
        @extend .fa;
        @extend .fa-terminal;
        color: map-get($colors, 'green');
      }

      &.option .icon {
        @extend .fa;
        @extend .fa-flag-o;
        color: map-get($colors, 'green');
      }

      &.branch .icon {
        @extend .octicon;
        @extend .octicon-git-branch;
      }

      &.highlighted {
        background-color: #383E4A;
      }
    }
  }

  .description {
    display: block;
    box-shadow: 0 4px 8px 1px rgba(0, 0, 0, 0.3);

    position: absolute;
    left: 0;
    right: 0;

    font-size: 0.8em;

    @include info-panel;
  }
}

.fixedsticky {
  top: 0;
}
